%%
% clear all
% clc
RandStream.setDefaultStream(RandStream('mt19937ar','seed',sum(100*clock)));

kd= 1300; % pg/ml, 850~1700
KR= 1; % nearly the same affinity 
G0=5.47; % initial point on t2d natural history in Tabak 2009, Lancet, Fig. 1 
Gb=5.84; % interpolated from the above figure
Gh=13.4; % 

IL0=12.0; 
RA0=IL0*500.0; 

ILh=IL0*25.8; 
RAh=RA0*1.3;

N=5000; 
ILb_array=IL0*(1.0 + (5-1)* rand(N,1)); % after search 
RAb_array=RA0*(1.0+ 0.8*rand(N,1)); % after search

obj53_array=zeros(N,1)+NaN;
hop53_array=zeros(N,1)+NaN;
obj31_array=zeros(N,1)+NaN;
hop31_array=zeros(N,1)+NaN;
leak=zeros(N,1)+NaN;

%%
for i=1: N
    i
    if mod(i,100)==1
       maple('restart')
       maple('k8:=log(2.0)/(0.3/24.0)');
       maple('k9:=log(2.0)/(0.1/24.0)');
       maple('F:=IL/(kd+IL+KR*RA)');
       maple('eqIL:= 1/(5.802+k4^2*IL^2)* (k5 * G^2.77/(3.528^2.77+G^2.77) + k6*(F^3)/(0.1575^3+F^3)) -k8*IL');
       maple('eqRA:= k1+k2*F-k3*F^2*RA-k9*RA ');
       maple('bif:=  diff(eqIL,RA)/diff(eqIL,IL) - diff(eqRA,RA)/diff(eqRA,IL) ');
       setmaple('kd',kd);     setmaple('KR',KR);
       setmaple('G0',G0);  setmaple('Gb',Gb);  setmaple('Gh',Gh);
       setmaple('IL0',IL0); setmaple('ILh',ILh); 
       setmaple('RA0',RA0); setmaple('RAh',RAh); 
              
       maple('ssIL0 := subs({G = G0, RA = RA0, IL = IL0 }, eqIL)');
       maple('ssILb := subs({G = Gb, RA = RAb, IL = ILb }, eqIL)');
       maple('ssILh := subs({G = Gh, RA = RAh, IL = ILh }, eqIL)');
       maple('ssRA0 := subs( { RA = RA0, IL = IL0 }, eqRA)');
       maple('ssRAb := subs( { RA = RAb, IL = ILb }, eqRA)');
       maple('ssRAh := subs( { RA = RAh, IL = ILh }, eqRA)');
    end
    tic
    setmaple('ILb',ILb_array(i));
    setmaple('RAb',RAb_array(i));
    para=maple('para:=solve({ssIL0,ssILb,ssILh,ssRA0,ssRAb,ssRAh},{k1,k2,k3,k4,k5,k6}, useassumptions) assuming k1>0,k2>0,k3>0,k4>0,k5>0,k6>0');
    if ~isempty(para)
        N1=maple('j:=0: for i in para[1] do j:=j+1; end do');
        N2=maple('j:=0: for i in para[1][1] do j:=j+1; end do');
        n=[eval(N1) eval(N2)];
        if n == [2 1] % only one set of solution
            obj= eval(maple('subs({ G=Gb,IL=ILb,RA=RAb,para[1],para[2],para[3],para[4],para[5],para[6]},bif)'));
            if abs(obj)< 5e-3
%                 obj_array(i)=obj;
                ss05=maple('ss05:=solve({subs(para[1],para[2],para[3],eqRA), subs(para[4],para[5],para[6],G=G0,eqIL)},{IL,RA},useassumptions) assuming IL>0, RA>0');
                ss03=maple('ss03:=solve({subs(para[1],para[2],para[3],eqRA), subs(para[4],para[5],para[6],G=Gb+0.2,eqIL)},{IL,RA},useassumptions) assuming IL>0, RA>0');
                M1=maple('j:=0: for i in ss05 do j:=j+1; end do');
                M2=maple('j:=0: for i in ss03 do j:=j+1; end do');
                m=[eval(M1) eval(M2)];
                if m== [5 3]
                    valueH(1)= eval(getmaple('rhs(ss03[1][1])'));
                    valueH(2)= eval(getmaple('rhs(ss03[2][1])'));
                    valueH(3)= eval(getmaple('rhs(ss03[3][1])'));
                    obj53_array(i) = obj;
                    hop53_array(i) = min( valueH );
                elseif m==[3 1]
                    valueH(1)= eval(getmaple('rhs(ss03[1][1])'));
                    obj31_array(i) = obj;
                    hop31_array(i) = valueH(1);
                end
            end
        else 
            leak(i)=1;
        end
    end
    toc
end
inx53=find(~isnan(obj53_array));
inx31=find(~isnan(obj31_array));
save('scan_bifur.mat') 
%%
ILp=ILb_array;
RAp=RAb_array;
ILp(inx53)=NaN;
Rap(inx53)=NaN;
subplot(1,2,1)
plot(RAp/RA0,ILp/IL0,'b.');
hold on
plot(RAb_array(inx53)/RA0,ILb_array(inx53)/IL0,'r.');
% xlim([1 2.5])
% ylim([1 1.5])
ylabel('L_b/L_c')
xlabel('A_b/A_c')
subplot(1,2,2)
plot(RAb_array(inx53)/RA0, hop53_array(inx53)/IL0,'r.')
hold on
% xlim([1 1.5])
% ylim([0 60])
xlabel('A_b/A_c')
ylabel('L_d/L_c')
