set_maple_parameter
%%
N=200;
G=linspace(1,20,N);
for i=1:51
    setmaple('G_p',G(i))
    ss05=maple('ss05:=solve({subs(para[1],para[2],para[3],eqRA), subs(para[4],para[5],para[6],G=G_p,eqIL)},{IL,RA},useassumptions) assuming IL>0, RA>0');
    valueL(i,1)= eval(getmaple('rhs(ss05[1][1])'));
    valueL(i,2)= eval(getmaple('rhs(ss05[2][1])'));
    valueL(i,3)= eval(getmaple('rhs(ss05[3][1])'));
    valueL(i,4)= eval(getmaple('rhs(ss05[4][1])'));
    valueL(i,5)= eval(getmaple('rhs(ss05[5][1])'));
    valueA(i,1)= eval(getmaple('rhs(ss05[1][2])'));
    valueA(i,2)= eval(getmaple('rhs(ss05[2][2])'));
    valueA(i,3)= eval(getmaple('rhs(ss05[3][2])'));
    valueA(i,4)= eval(getmaple('rhs(ss05[4][2])'));
    valueA(i,5)= eval(getmaple('rhs(ss05[5][2])'));
    i
end 

for i=52:N
    setmaple('G_p',G(i))
    ss03=maple('ss03:=solve({subs(para[1],para[2],para[3],eqRA), subs(para[4],para[5],para[6],G=G_p,eqIL)},{IL,RA},useassumptions) assuming IL>0, RA>0');
    valueL(i,1)= eval(getmaple('rhs(ss03[1][1])'));
    valueL(i,2)= eval(getmaple('rhs(ss03[2][1])'));
    valueL(i,3)= eval(getmaple('rhs(ss03[3][1])'));
    valueA(i,1)= eval(getmaple('rhs(ss03[1][2])'));
    valueA(i,2)= eval(getmaple('rhs(ss03[2][2])'));
    valueA(i,3)= eval(getmaple('rhs(ss03[3][2])'));
    i
end
save('data_for_bifur_plot.mat')
%% 
clear all
load data_for_bifur_plot.mat
figure; 
subplot(2,1,1)
semilogy(G(1:end),[valueL(1:51,5); valueL(52:end,3)],'k-','LineWidth',2.5)
hold on
semilogy([G(1:51) G(1:end)],[valueL(1:51,2);[valueL(1:51,4); valueL(52:end,2)]],'.')
semilogy(G(1:end),[valueL(1:51,3); valueL(52:end,1)],'r-','LineWidth',2.5)
semilogy(G(1:51),valueL(1:51,1),'g-','LineWidth',2.5)

xlim([1 12])
xlabel('G (mM)')
ylabel('IL-1{\beta} (pg/ml)')
legend('strong disease phase','unstable','mild disease phase','compensation phase','Location','SouthEast' )

%% plot nullcline switch at bifurcation
maple('term1:=subs({para[5],para[6],para[4]},eqIL)');
maple('term2:=subs({para[2],para[3],para[1]},eqRA)');
subplot(2,1,2)

hold on; box on

maple('implicitplot(term2, IL=0..1900,RA=5000..12000, color="Black",gridrefine=7)')
maple('implicitplot(subs(G=4.5,term1), IL=0..1900,RA=5000..12000, color="Red",gridrefine=7)')
ax1=gca;
set(ax1,'TickDir','in','TickLength',[.001 0]);
legend('IL-1Ra=0','IL-1{\beta}=0','Location','NorthEast' )
rectangle('Position',[5,5150,30,1500])
xlabel('IL-1{\beta} (pg/ml)')
ylabel('IL-1Ra (pg/ml)')
ylim([5000 12000])
ax2=axes('pos',[0.23,0.17,0.45,0.35]);
hold on; box on;
set(ax2,'XTickLabel',{})
set(ax2,'YTickLabel',{})

maple('implicitplot(term2, IL=0..1900,RA=5000..12000, color="Black",gridrefine=7)')
maple('implicitplot(subs(G=4.5,term1), IL=0..90,RA=5000..8000, color="Red",gridrefine=7)')
maple('implicitplot(subs(G=Gb,term1), IL=0..90,RA=5000..8000, color="Blue",gridrefine=7)')
maple('implicitplot(subs(G=Gb+1,term1), IL=0..90,RA=5000..8000, color="Green",gridrefine=7)')
xlim([5 35])
ylim([5000 7000])

%% plot nullclines 
maple('ilim:=2800');
maple('rlim:=15000');
figure
subplot(2,2,1)
maple('animate(implicitplot,[[term1,term2],IL=0..ilim,RA=0..rlim,color=["Red","Teal"],legend=[plot1,plot2],gridrefine=3],G=G0..G0)')
title('G0')
xlabel('IL-1{\beta}')
ylabel('IL-1Ra')
box on
subplot(2,2,2)
maple('animate(implicitplot,[[term1,term2],IL=0..ilim,RA=0..rlim,color=["Red","Teal"],legend=[plot1,plot2],gridrefine=3],G=Gb..Gb)')
title('Gb')
xlabel('IL-1{\beta}')
ylabel('IL-1Ra')
box on
subplot(2,2,3)
maple('animate(implicitplot,[[term1,term2],IL=0..ilim,RA=0..rlim,color=["Red","Teal"],legend=[plot1,plot2],gridrefine=3],G=Gh..Gh)')
title('Gh')
xlabel('IL-1{\beta}')
ylabel('IL-1Ra')
box on
subplot(2,2,4)
maple('animate(implicitplot,[[term1,term2],IL=0..ilim,RA=0..rlim,color=["Red","Teal"],legend=[plot1,plot2],gridrefine=3],G=4*Gh..4*Gh)')
title('4*Gh')
xlabel('IL-1{\beta}')
ylabel('IL-1Ra')
box on
