set_maple_parameter
figure
%%  therapy 
maple('term1:=subs({para[5],para[6],para[4]},eqIL)');
maple('term2:=subs({para[2],para[3],para[1]},eqRA)');

subplot(2,2,1)
hold on; box on
plot(12,6000, 'ro','LineWidth',2,'MarkerSize',10);
plot(676.3,1.078e4, 'ks','LineWidth',2,'MarkerSize',10);
legend('state restored by glucose-lowering therapy', 'unaffected overt T2D')
maple('implicitplot(term2, IL=0..1900,RA=5000..13500, color="Black",gridrefine=7)')
% maple('implicitplot(subs(G=Gh,term1), IL=0..1900,RA=5000..12500, color="Red",gridrefine=7)')
maple('implicitplot(subs(G=G0,term1), IL=0..1900,RA=5000..12500, color="Red",gridrefine=7)')
ax1=gca;
set(ax1,'TickDir','in','TickLength',[.001 0]);
xlabel('IL-1{\beta}(pg/ml)')
ylabel('IL-1Ra(pg/ml)')
% plot(11.72,1.112098e4, 'ro','LineWidth',1,'MarkerSize',10);

subplot(2,2,2)
hold on; box on
plot(415.3,1.112e4, 'rx','LineWidth',2,'MarkerSize',10);
plot(11.72,1.2e4, 'g^','LineWidth',2,'MarkerSize',10);
legend('state induced by weak IL-1Ra therapy','state induced by strong IL-1Ra therapy')
plot(676.3,1.078e4, 'ks','LineWidth',2,'MarkerSize',10);
maple('implicitplot(term2, IL=0..1900,RA=5000..13500, color="Black",gridrefine=7)')
maple('implicitplot(subs(G=Gh,term1), IL=0..1900,RA=5000..12500, color="Red",gridrefine=7)')
ax1=gca;
set(ax1,'TickDir','in','TickLength',[.001 0]);
line([0 1900],[1.112e4 1.112e4])
line([0 1900],[1.2e4 1.2e4])
xlabel('IL-1{\beta}(pg/ml)')
ylabel('IL-1Ra(pg/ml)')

subplot(2,2,3)
hold on; box on
plot(11.72,1.2e4, 'r.','LineWidth',2,'MarkerSize',25);
plot(12,6000, 'bo','LineWidth',2,'MarkerSize',10);
legend('state induced by the combined therapy','state after withdraw of IL-1Ra therapy')
plot(676.3,1.078e4, 'ks','LineWidth',2,'MarkerSize',10);
% maple('implicitplot(term2, IL=0..1900,RA=5000..13500, color="Black",gridrefine=7)')
% maple('implicitplot(subs(G=Gh,term1), IL=0..1900,RA=5000..12500, color="Red",gridrefine=7)')
ax1=gca;
set(ax1,'TickDir','in','TickLength',[.001 0]);
line([0 1900],[1.2e4 1.2e4])
% plot(11.72,1.2e4, 'ro','LineWidth',1.5,'MarkerSize',12.5);
% plot(676.3,1.078e4, 'ro','LineWidth',1,'MarkerSize',10);

maple('implicitplot(term2, IL=0..1900,RA=5000..13500, color="Black",gridrefine=7)')
maple('implicitplot(subs(G=G0,term1), IL=0..1900,RA=5000..12500, color="Red",gridrefine=7)')
set(ax1,'TickDir','in','TickLength',[.001 0]);
% plot(11.72,1.2e4, 'ro','LineWidth',1,'MarkerSize',10);
% plot(676.3,1.078e4, 'ro','LineWidth',1,'MarkerSize',10);
% plot(12,6000, 'ro','LineWidth',2,'MarkerSize',15);
xlabel('IL-1{\beta}(pg/ml)')
ylabel('IL-1Ra(pg/ml)')

%% B mass 
subplot(2,2,4)

load glu_homaS_from_tabak.mat
load initial_condition.mat
time_year=time_day/365-13;

T_therapyStart= time_day(end) ;
T_therapyRelease= T_therapyStart + 365*3;
T_simulationEnd= T_therapyRelease + 365*15; 
A_clamp_high=12000;
A_clamp_low=11120;
G_clamp=5.47;

y0=[G_incidence I_incidence IL_incidence RA_incidence B_incidence]';
[t0, y_natural] = ode15s(@(t,y) myode_therapy(t,y, time_day, homa_s_incidence,1,1), (0:365:T_simulationEnd), y0);

[~, y_before_therapy]=ode15s(@(t,y) myode_therapy(t,y, time_day, homa_s_incidence, 1,1), (0:365:T_therapyStart), y0);

% clamp G 
y0_gClamp= [G_clamp y_before_therapy(end,2:5)];
[t_g, y_g_therapy]=ode15s(@(t,y) myode_therapy(t,y, time_day, homa_s_incidence, 0,1), (T_therapyStart:365:T_simulationEnd),y0_gClamp);
% clamp A 
y0_aClampHigh= [y_before_therapy(end,1:3) A_clamp_high y_before_therapy(end,5)];
y0_aClampLow=  [y_before_therapy(end,1:3) A_clamp_low y_before_therapy(end,5)];
[t_aHigh, y_aHigh]=ode15s(@(t,y) myode_therapy(t,y, time_day, homa_s_incidence, 1,0),(T_therapyStart:365:T_simulationEnd), y0_aClampHigh);
[t_aLow, y_aLow]=ode15s(@(t,y) myode_therapy(t,y, time_day, homa_s_incidence, 1,0),(T_therapyStart:365:T_simulationEnd), y0_aClampLow);
% clamp G A 
y0_gaClamp= [G_clamp y_before_therapy(end,2:3) A_clamp_high y_before_therapy(end,5)];
[t_ga, y_ga_therapy]=ode15s(@(t,y) myode_therapy(t,y, time_day, homa_s_incidence, 0,0),(T_therapyStart:365:T_simulationEnd), y0_gaClamp);
% clamp G, A is temporarily clamped 
[t1_ga, y1_ga_therapy]=ode15s(@(t,y) myode_therapy(t,y, time_day, homa_s_incidence, 0,0),(T_therapyStart:365:T_therapyRelease), y0_gaClamp);
[t2_ga, y2_ga_therapy]=ode15s(@(t,y) myode_therapy(t,y, time_day, homa_s_incidence, 0,1),(T_therapyRelease:365:T_simulationEnd), y1_ga_therapy(end,:));

hold on; box on
plot(t0/365-13, y_natural(:,5),'k') % natural history
plot(t_g/365-13,y_g_therapy(:,5),'ks') % G clamp
plot(t_aLow/365-13,y_aLow(:,5),'rx') % A clamp low 
plot(t_aHigh/365-13,y_aHigh(:,5),'g^') % A clamp high
plot(t_ga/365-13,y_ga_therapy(:,5),'r.') % A G clamp
plot(t1_ga/365-13,y1_ga_therapy(:,5),'r.') % A G clamp, then release A 
plot(t2_ga/365-13,y2_ga_therapy(:,5),'bo') % A G clamp, then release A 

xlabel('Year')
ylabel('{\beta} cell mass (mg)')

