clear all
clc
load glu_homaS_from_tabak.mat
load initial_condition.mat
%% 6 years
T_therapyStart= time_day(end) + 6*365;
T_therapyRelease= T_therapyStart + 30*3;
y0=[G_incidence I_incidence IL_incidence RA_incidence B_incidence]';
% condition at trial start
[t0, y_start_6] = ode15s(@(t,y) myode_therapy(t,y, time_day, homa_s_incidence,1,1), [0 T_therapyStart], y0);
% control patient 
[t0, y_control_end] = ode15s(@(t,y) myode_therapy(t,y, time_day, homa_s_incidence,1,1), [T_therapyStart T_therapyRelease], y_start_6(end,:));
% dose
dose_array=[y_start_6(end,4):20:12000 12100:500:24100];
% therapy patient  
for i=1:length(dose_array)
    [t1_a, y1_a]=ode15s(@(t,y) myode_therapy(t,y, time_day, homa_s_incidence,1,0), [T_therapyStart T_therapyRelease], [ y_start_6(end,1:3) dose_array(i) y_start_6(end,5)] );
    g1(i)=y1_a(end,1)-y_control_end(end,1);
end
f1=figure;
plot((dose_array)-y_start_6(end,4), g1, 'ro'); 
hold on

%% 11 years
T_therapyStart= time_day(end) + 11*365;
T_therapyRelease= T_therapyStart + 30*3;
y0=[G_incidence I_incidence IL_incidence RA_incidence B_incidence]';
% condition at trial start
[t0, y_start_11] = ode15s(@(t,y) myode_therapy(t,y, time_day, homa_s_incidence,1,1), [0 T_therapyStart], y0);
y_start_11=[y_start_11(end,1:2) 1781 5998 y_start_11(end,5)];
% control patient 
[t0, y_control_end] = ode15s(@(t,y) myode_therapy(t,y, time_day, homa_s_incidence,1,1), [T_therapyStart T_therapyRelease], y_start_11);
% dose 
dose_array=[y_start_11(4):100:12000 12100:500:20100];
for i=1:length(dose_array)
    [t2_a, y2_a]=ode15s(@(t,y) myode_therapy(t,y, time_day, homa_s_incidence,1,0), [T_therapyStart T_therapyRelease], [y_start_11(1:3), dose_array(i), y_start_11(5)]);
    g2(i)=y2_a(end,1)-y_control_end(end,1);
end

plot((dose_array)-y_start_11(4), g2, 'k.');
xlabel('IL-1Ra clamp above endogenous level (pg/ml)')
ylabel('Glucose improvement vs. control (mM)')
xlim([0 1.5e4])
legend('short mild T2D state', 'long strong T2D state')

% option= struct('Color','rgb','Bounds','tight','Resolution',3000);
% exportfig(f1,'doseCompare.eps',option)
