clear all 
clc
load deopt_my.mat

idx=find(Fval< 0.015);
FM_ui=FM_ui(idx,:);
Fval= Fval(idx);
%%

m_array = FM_ui(:,1);
tao_array = FM_ui(:,2);
k3_array= FM_ui(:,3);
k4_array= FM_ui(:,4);

k1_array = -0.9427548911* k3_array + 972333.4465;
k2_array = 584.2988074  * k3_array + 0.1571988193e8;
k5_array = 4997.881428 - 562019.8042* k4_array .*k4_array;
k6_array = 0.5916023335e7  + 0.4677802005e12* k4_array .*k4_array;

figure;
semilogy((m_array),'b-')
hold on
semilogy((tao_array),'r-')
semilogy((k3_array),'b.')
semilogy((k4_array),'r.')
legend('m','tao','k3','k4') % figure S1

%% history 
load glu_homaS_from_tabak.mat
load initial_condition.mat
time_day_long = [ time_day',4745+365: 365: 4745+30*365]';
time_year= time_day/365-13;
time_year_long= time_day_long/365-13;

y0=[G_incidence I_incidence IL_incidence RA_incidence B_incidence]';

y=zeros(length(time_year),length(Fval));
for i=1:length(Fval)
    %     pm= min(m_array)  + rand*(max(m_array)-min(m_array));
    %     ptao= min(tao_array) + rand*(max(tao_array)-min(tao_array));
    %     pk1 = min(k1_array) + rand*(max(k1_array)-min(k1_array));
    %     pk2 = min(k2_array) + rand*(max(k2_array)-min(k2_array));
    %     pk3 = min(k3_array) + rand*(max(k3_array)-min(k3_array));
    %     pk4 = min(k4_array) + rand*(max(k4_array)-min(k4_array));
    %     pk1 = -0.9427548911* pk3 + 972333.4465;
    %     pk2 = 584.2988074  * pk3 + 0.1571988193e8;
    %     pk5 = 4997.881428 - 562019.8042* pk4 .*pk4;
    %     pk6 = 0.5916023335e7  + 0.4677802005e12* pk4 .*pk4;
    %     pk5 = min(k5_array) + rand*(max(k5_array)-min(k5_array));
    %     pk6 = min(k6_array) + rand*(max(k6_array)-min(k6_array));
    pm = m_array(i);
    ptao = tao_array(i);
    pk1 = k1_array(i);
    pk2 = k2_array(i);
    pk3 = k3_array(i);
    pk4 = k4_array(i);
    pk5 = k5_array(i);
    pk6 = k6_array(i);
    [~, y_incidnece] = ode15s(@(t,y) myode_all_para_perturb(t,y, time_day, homa_s_incidence, pm,ptao,pk1,pk2,pk3,pk4,pk5,pk6 ), time_day_long, y0);
    g(:,i)= y_incidnece(:,1);
    l(:,i)= y_incidnece(:,3);
    a(:,i)= y_incidnece(:,4);
    b(:,i)= y_incidnece(:,5);
end 
%%
tt= [time_year', fliplr(time_year')];
y1= min(g(1:length(time_year),:),[],2);
y2= max(g(1:length(time_year),:),[],2);
yy= [y1', fliplr(y2')];
f1=figure;
subplot(2,2,1)
fill(tt,yy,'g')
hold on
plot(time_year,glu_incidence,'k')

y1= min(l(1:length(time_year),:),[],2);
y2= max(l(1:length(time_year),:),[],2);
yy= [y1', fliplr(y2')];
subplot(2,2,2)
fill(tt,yy,'g')

y1= min(a(1:length(time_year),:),[],2);
y2= max(a(1:length(time_year),:),[],2);
yy= [y1', fliplr(y2')];
subplot(2,2,3)
fill(tt,yy,'g')

y1= min(b(1:length(time_year),:),[],2);
y2= max(b(1:length(time_year),:),[],2);
yy= [y1', fliplr(y2')];
subplot(2,2,4)
fill(tt,yy,'g')

figure
subplot(2,2,1)
plot(time_year_long,g)
subplot(2,2,2)
plot(time_year_long,l)
subplot(2,2,3)
plot(time_year_long,a)
subplot(2,2,4)
plot(time_year_long,b)