clear all 
clc
load deopt_my_used.mat

% idx=find(Fval< 0.015);
% FM_ui=FM_ui(idx,:);
% Fval= Fval(idx);
%%

m_array = FM_ui(:,1);
tao_array = FM_ui(:,2);

figure;
semilogy((m_array),'b-')
hold on
semilogy((tao_array),'r-')
legend('m','tao') % figure S1

%% history 
load glu_homaS_from_tabak.mat
load initial_condition.mat
time_day_long = [ time_day',4745+365: 365: 4745+30*365]';
time_year= time_day/365-13;
time_year_long= time_day_long/365-13;

y0=[G_incidence I_incidence IL_incidence RA_incidence B_incidence]';
k1= 947302.2872        ;
k2= 31233645.51        ;
k3= 26551.07864        ;
k4= 0.04720128697      ;
k5= 3745.722947        ;
k6= 1048112296         ;

y=zeros(length(time_year),length(Fval));
for i=1:length(Fval)
    %     pm= min(m_array)  + rand*(max(m_array)-min(m_array));
    %     ptao= min(tao_array) + rand*(max(tao_array)-min(tao_array));
    
    pm = m_array(i);
    ptao = tao_array(i);
    pk1 = k1;
    pk2 = k2;
    pk3 = k3;
    pk4 = k4;
    pk5 = k5;
    pk6 = k6;
    [~, y_incidnece] = ode15s(@(t,y) myode_all_para_perturb(t,y, time_day, homa_s_incidence, pm,ptao,pk1,pk2,pk3,pk4,pk5,pk6 ), time_day_long, y0);
    g(:,i)= y_incidnece(:,1);
    l(:,i)= y_incidnece(:,3);
    a(:,i)= y_incidnece(:,4);
    b(:,i)= y_incidnece(:,5);
end 
%%
tt= [time_year', fliplr(time_year')];
y1= min(g(1:length(time_year),:),[],2);
y2= max(g(1:length(time_year),:),[],2)
yy= [y1', fliplr(y2')];
f1=figure;
subplot(2,2,1)
fill(tt,yy,'g')
hold on
plot(time_year,glu_incidence,'k')

y1= min(l(1:length(time_year),:),[],2);
y2= max(l(1:length(time_year),:),[],2);
yy= [y1', fliplr(y2')];
subplot(2,2,2)
fill(tt,yy,'g')

y1= min(a(1:length(time_year),:),[],2);
y2= max(a(1:length(time_year),:),[],2)
yy= [y1', fliplr(y2')];
subplot(2,2,3)
fill(tt,yy,'g')

y1= min(b(1:length(time_year),:),[],2);
y2= max(b(1:length(time_year),:),[],2)
yy= [y1', fliplr(y2')];
subplot(2,2,4)
fill(tt,yy,'g')

figure
subplot(2,2,1)
plot(time_year_long,g)
subplot(2,2,2)
plot(time_year_long,l)
subplot(2,2,3)
plot(time_year_long,a)
subplot(2,2,4)
plot(time_year_long,b)