%% set maple with relevant varables 
clear all
clc
load scan_bifur.mat % result of para scan 
load fit_para_from_experiments.mat
clear m 

dL=log(2.0)/(0.3/24.0);
dA=log(2.0)/(0.1/24.0);
maple('restart')
maple('with(plots)');
maple('F:=IL/(kd+IL+KR*RA)');
maple('eqIL:= 1/(5.802+k4^2*IL^2)* (k5 * G^2.77/(3.528^2.77+G^2.77) + k6*(F^3)/(0.1575^3+F^3)) -dL*IL');
maple('eqRA:= k1+k2*F-k3*F^2*RA-dA*RA ');

setmaple('kd',kd);
setmaple('KR',KR);
setmaple('G0',G0);
setmaple('Gb',Gb);
setmaple('Gh',Gh);
setmaple('IL0',IL0);
setmaple('ILh',ILh);
setmaple('RA0',RA0); 
setmaple('RAh',RAh);
setmaple('dL',dL); 
setmaple('dA',dA);

maple('ssIL0 := subs({G = G0, RA = RA0, IL = IL0 }, eqIL)');
maple('ssILb := subs({G = Gb, RA = RAb, IL = ILb }, eqIL)');
maple('ssILh := subs({G = Gh, RA = RAh, IL = ILh }, eqIL)');
maple('ssRA0 := subs( { RA = RA0, IL = IL0 }, eqRA)');
maple('ssRAb := subs( { RA = RAb, IL = ILb }, eqRA)');
maple('ssRAh := subs( { RA = RAh, IL = ILh }, eqRA)');

inx=inx53;
obj_array=obj53_array;
hop_array=hop53_array;

[maxhop, j]=min(abs(hop_array(inx)-ILh));
setmaple('ILb',ILb_array(inx(j)));
setmaple('RAb',RAb_array(inx(j)));
para=maple('para:=solve({ssIL0,ssILb,ssILh,ssRA0,ssRAb,ssRAh},{k1,k2,k3,k4,k5,k6}, useassumptions) assuming k1>0,k2>0,k3>0,k4>0,k5>0,k6>0');
k1=eval(getmaple('rhs(para[1])'));
k2=eval(getmaple('rhs(para[2])'));
k3=eval(getmaple('rhs(para[3])'));
k4=eval(getmaple('rhs(para[4])'));
k5=eval(getmaple('rhs(para[5])'));
k6=eval(getmaple('rhs(para[6])'));
